--------
EINGABE:
--------

<h1>TvsGB - Gästebuch</h1>


--------
AUSGABE:
--------

<?php

	global $REX;
	$mypage = "tvsgb";
	
	$table_pre = "rex_".$REX['ADDON']['rxid'][$mypage];
	$art_table = $table_pre . "_entries";

	$myIniFile = $REX['INCLUDE_PATH'] . "/addons/" . $mypage . "/" . $mypage . ".ini";

	if (file_exists($myIniFile)) {
		$stringData = file_get_contents($myIniFile);
		$settings = parse_ini_file($myIniFile);
	}

	if($REX['REDAXO'] != 1) {

		$infomail		= $settings['info_mail'];
		$frommail		= $settings['from_mail'];
		$highlightpw	= $settings['highlight_pw'];
		$max_entries	= $settings['max_entries'];
		$confirmstring	= $settings['confirmstring'];
		$allowreplies	= $settings['allow_replies'];
		
		if ($settings['lock_gb'] == 1) {
			$sperren		= true;
		} else {
			$sperren		= false;
		};

		// $output .=_r($_GET);
		// $output .=_r($_POST);
		
		$id = rex_get('tvsgb_id', 'int', 0);
		$mode = rex_get('mode', 'string', '');
		$name = rex_post('name', 'string', '');
		$email = rex_post('email', 'string', '');
		$web = rex_post('web', 'string', '');
		$eintrag = rex_post('eintrag', 'string', '');
		$ergebnis = rex_post('ergebnis', 'string', '');

		// *******
		// Main...
		// *******

		$output = "<div id=\"gbook\">";
		// $output .=_r($HTTP_GET_VARS);

		//
		// Speichern neuer Eintrag...
		//

		if ($mode == "put")
		{
			if (strtoupper($ergebnis) == strtoupper($confirmstring)) {

				$sql = new rex_sql();
				$sql->setQuery("INSERT INTO " . $art_table . " (create_user, email, web, description, clang, status, create_date) VALUES ('" . $name . "', '" . $email . "', '" . $web . "', '" . $eintrag . "', 0, 1, " . time() . ")");

				// Infomail senden
				if ($infomail != "")
				{
					mail($infomail, "Neuer Gästebucheintrag am " . date("d.m.Y H:i:s"), "$email\n$web\n$eintrag\n" . date("d.m.Y H:i:s") . "\n","from:$frommail", "-f" . $frommail);
				}
			}

			$output .= "<body onLoad=\"javascript:window.location.href='" . rex_getUrl('','', array('mode'=>'view'), '&amp;') . "';\">";
		}
		
		//
		// Zeigen des Gästebuchs...
		//
		if ($max_entries != 0)
		{
			if ($mode == "view" || $mode == "")
			{

				if (!isset($tvsgb_start))
					$tvsgb_start = 0;

				if (rex_get('tvsgb_start', 'int', 0) != 0) {
					$tvsgb_start = rex_get('tvsgb_start', 'int', 0);
					$tvsgb_limit = $max_entries;
				}
				else
					if ($max_entries == "") {
						$tvsgb_start = 0;
						$tvsgb_limit = 99;
					}
					else {
						$tvsgb_start = 0;
						$tvsgb_limit = $max_entries;
					}
				$sql_limit = " LIMIT " . $tvsgb_start . ", " . $tvsgb_limit;

				$sql = new rex_sql();
				$sql->setQuery("SELECT * FROM " . $art_table . " WHERE status = 1 ORDER BY create_date DESC");
				$total_rows = $sql->getRows();

				if ($sperren == false) {
					$output .= "<input type=\"button\" value=\"Neuer Eintrag\" onClick=\"window.location.href='" . rex_getUrl('','', array('mode'=>'add'), '&amp;') . "';\" /><br /><p>&nbsp;</p>\n";
				}
				
				$sql->setQuery("SELECT * FROM " . $art_table . " WHERE status = 1 ORDER BY create_date DESC" . $sql_limit);
				$current_rows = $sql->getRows();
				if ($current_rows > 0 ) {
					for ($i = 1; $i <= $current_rows; $i++) {
						if ($sql->getValue('email') == $highlightpw)
							$output .= "<div class=\"gb-highlight\">";
						else
							$output .= "<div class=\"gb-entry\">";
						$output .= "	<div class=\"gb-nr\">" . $sql->getValue('id') . "</div><div class=\"gb-top\">";
						if ($sql->getValue('web') != "")
							$output .= "<a href=\"" . $sql->getValue('web') . "\" target=\"_blank\">";
						$output .= $sql->getValue('create_user');
						if ($sql->getValue('web') != "")
							$output .= "</a>";
						$output .= " schrieb am " . date("d.m.Y H:i:s", $sql->getValue('create_date'));
						if ($sql->getValue('email') != "")
							$output .= " [<a href=\"" . rex_getUrl('','', array('mode'=>'reply', 'tvsgb_id'=>$sql->getValue('id')), '&amp;') . "\">Antworten</a>]";
						$output .= "	</div>\n";
						$output .= "	<div class=\"gb-text\"><br />" . $sql->getValue('description') . "</div>\n";
						$output .= "</div>";

						$sql->next();
					}
					if ($tvsgb_start > 0)
						$output .= "<div id=\"gb-links\"><a href=\"" . rex_getUrl('','', array('tvsgb_start'=>trim(($tvsgb_start - $max_entries))), '&amp;') . "\">&laquo; Vorherige Seite</a></div>";
					if ($tvsgb_start + $max_entries < $total_rows)
						$output .= "<div id=\"gb-rechts\"><a href=\"" . rex_getUrl('','', array('tvsgb_start'=>trim(($tvsgb_start + $max_entries))), '&amp;') . "\">Nächste Seite &raquo;</a></div>";
				}
				else {
					$output .= "<p><br />Es wurde noch kein Eintrag dem Gästebuch hinzugef&uuml;gt.</p>\n";
				}
			}
			elseif ($mode == "reply") {
				$output .= "<script type=\"text/javascript\">\n";
				$output .= "<!--\n";
				$output .= "function trim (zeichenkette) {";
				$output .= "	return zeichenkette.replace (/^\s+/, '').replace (/\s+$/, '');";
				$output .= "}";
				$output .= "function chkPost()\n";
				$output .= "{\n";
				$output .= "		if(document.gb_postentry.name.value == '')\n";
				$output .= "		{\n";
				$output .= "			alert(\"Bitte einen Namen eingeben!\");\n";
				$output .= "			document.gb_postentry.name.focus();\n";
				$output .= "			return false;\n";
				$output .= "		}\n";
				$output .= "		if(trim(document.gb_postentry.eintrag.value) == '')\n";
				$output .= "		{\n";
				$output .= "			alert(\"Bitte einen Eintrag vornehmen!\");\n";
				$output .= "			document.gb_postentry.eintrag.focus();\n";
				$output .= "			return false;\n";
				$output .= "		}\n";
				$output .= "		if(document.gb_postentry.email.value == '')\n";
				$output .= "		{\n";
				$output .= "			alert(\"Bitte eine EMail-Adresse angeben!\");\n";
				$output .= "			document.gb_postentry.email.focus();\n";
				$output .= "			return false;\n";
				$output .= "		}\n";
				$output .= "}\n";
				$output .= "//-->\n";
				$output .= "</script>\n";

				$output .= "<form action=\"" . rex_getUrl('','', array('mode'=>'post_reply','tvsgb_id'=>$id), '&amp;') . "\" name=\"gb_postentry\" method=\"post\" onSubmit=\"return chkPost()\">\n";
				$output .= "	<fieldset>\n";
				$output .= "		<legend>Antworte dem Autor dieses Eintrags</legend>\n";
				$output .= "		<label for=\"name\">Name:</label><input type=\"text\" name=\"name\" id=\"name\" value=\"\" /><br />\n";
				$output .= "		<label for=\"email\">E-Mail:</label><input type=\"text\" name=\"email\" id=\"email\" value=\"\" /><br />\n";
				$output .= "		<label for=\"eintrag\">Kommentar:</label><textarea name=\"eintrag\" id=\"eintrag\" /></textarea><br />\n";
				$output .= "		<input type=\"submit\" value=\"Abschicken\" id=\"submit\" />\n";
				$output .= "		<input type=\"button\" value=\"Abbrechen\" id=\"submit2\" onClick=\"window.location.href='" . rex_getUrl('','', array('mode'=>'view'), '&amp;') . "';\" />\n";
				$output .= "	</fieldset>\n";
				$output .= "</form>\n";
			}
			elseif ($mode == "post_reply") {
				$sql->setQuery("SELECT * FROM " . $art_table . " WHERE id = " . $id);
				$current_rows = $sql->getRows();
				if ($current_rows > 0 ) {
					$destmail = ($sql->getValue('email') == $highlightpw) ? $infomail : $sql->getValue('email');
					$destbody =  "$name [$email]\n schrieb Dir am " . date("d.m.Y H:i:s") . ":\n$eintrag\n";
					if ($destmail != "")
					if (mail($destmail, "Antwort auf Deinen Gästebucheintrag vom " . date("d.m.Y H:i:s", $sql->getValue('create_date')) . " bei " . $REX['SERVERNAME'], $destbody, "from:".$email, "-f".$email))
						$output .= "Deine Antwort wurde verschickt, <a href=" . rex_getUrl('','', array('mode'=>'view'), '&amp;') . ">klicke hier um zum Gästebuch zurückzukehren</a>!";
					else
						$output .= "Deine Antwort konnte scheinbar nicht erfolgreich verschickt werden, <a href=" . rex_getUrl('','', array('mode'=>'view'), '&amp;') . ">klicke hier um zum Gästebuch zurückzukehren</a>!";
				}
			}
		}
		else
		{
			$output = "<p>Das Gästebuch ist zu Wartungszwecken derzeit deaktiviert. Bitte versucht es doch später noch einmal.</p>\n";
		}
		//
		// Formular für neuen Eintrag...
		//
		if ($mode == "add")
		{
			$output .= "<script type=\"text/javascript\">\n";
			$output .= "<!--\n";
			$output .= "function trim (zeichenkette) {";
			$output .= "	return zeichenkette.replace (/^\s+/, '').replace (/\s+$/, '');";
			$output .= "}";
			$output .= "function chkFormular()\n";
			$output .= "{\n";
			$output .= "		if(document.gb_addentry.name.value == '')\n";
			$output .= "		{\n";
			$output .= "			alert(\"Bitte einen Namen eingeben!\");\n";
			$output .= "			document.gb_addentry.name.focus();\n";
			$output .= "			return false;\n";
			$output .= "		}\n";
			$output .= "		if(trim(document.gb_addentry.eintrag.value) == '')\n";
			$output .= "		{\n";
			$output .= "			alert(\"Bitte einen Eintrag vornehmen!\");\n";
			$output .= "			document.gb_addentry.eintrag.focus();\n";
			$output .= "			return false;\n";
			$output .= "		}\n";
			$output .= "		if(document.gb_addentry.ergebnis.value == '')\n";
			$output .= "		{\n";
			$output .= "			alert(\"Bitte bestätigen Sie Ihren Eintrag!\");\n";
			$output .= "			document.gb_addentry.ergebnis.focus();\n";
			$output .= "			return false;\n";
			$output .= "		}\n";
			$output .= "}\n";
			$output .= "//-->\n";
			$output .= "</script>\n";

			$output .= "<form action=\"" . rex_getUrl('','', array('mode'=>'put'), '&amp;') . "\" name=\"gb_addentry\" method=\"post\" onSubmit=\"return chkFormular()\">\n";
			$output .= "	<fieldset>\n";
			$output .= "		<legend>Neuer Eintrag</legend>\n";
			$output .= "		<label for=\"name\">Name:</label><input type=\"text\" name=\"name\" id=\"name\" value=\"\" /><br />\n";
			$output .= "		<label for=\"email\">E-Mail:</label><input type=\"text\" name=\"email\" id=\"email\" value=\"\" /><br />\n";
			$output .= "		<label for=\"web\">Webseite:</label><input type=\"text\" name=\"web\" id=\"web\" value=\"\" /><br />\n";
			$output .= "		<label for=\"eintrag\">Kommentar:</label><textarea name=\"eintrag\" id=\"eintrag\" /></textarea><br />\n";
			$output .= "		<label for=\"ergebnis\">Zum Schutz vor SPAM bitten wir Sie, Ihren Eintrag durch Eingabe von '" . $confirmstring . "' zu bestätigen:</label><input type=\"text\" name=\"ergebnis\" id=\"ergebnis\" value=\"\" /><br />\n";
			$output .= "		<input type=\"submit\" value=\"Speichern\" id=\"submit\" />\n";
			$output .= "		<input type=\"button\" value=\"Abbrechen\" id=\"submit2\" onClick=\"window.location.href='" . rex_getUrl('','', array('mode'=>'view'), '&amp;') . "';\" />\n";
			$output .= "	</fieldset>\n";
			$output .= "</form>\n";
		}

		$output .= "</div>";
		echo $output;
	}
	else
		echo "Gästebuchausgabe mit " . $settings['max_entries'] . " Einträgen pro Seite...";
?>
